searchNodes=[{"ref":"SvelteRender.html","title":"SvelteRender","type":"module","doc":"Svelte Renderer"},{"ref":"SvelteRender.html#child_spec/1","title":"SvelteRender.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"SvelteRender.html#get_html/2","title":"SvelteRender.get_html/2","type":"function","doc":"Given the component_path and props, returns html. component_path is the path to your svelte component module relative to the render service. props is a map of props given to the component. Must be able to turn into json"},{"ref":"SvelteRender.html#render/2","title":"SvelteRender.render/2","type":"function","doc":"Same as get_html/2 but wraps html in a div which is used to hydrate svelte component on client side. This is the preferred function when using with Phoenix component_path is the path to your svelte component module relative to the render service. props is a map of props given to the component. Must be able to turn into json"},{"ref":"SvelteRender.html#start_link/1","title":"SvelteRender.start_link/1","type":"function","doc":"Starts the SvelteRender and workers. Options :render_service_path - (required) is the path to the svelte render service relative to your current working directory :pool_size - (optional) the number of workers. Defaults to 4"},{"ref":"SvelteRender.html#stop/0","title":"SvelteRender.stop/0","type":"function","doc":"Stops the SvelteRender and underlying node svelte render service"},{"ref":"SvelteRender.RenderError.html","title":"SvelteRender.RenderError","type":"exception","doc":"Error when unable to render given component"},{"ref":"readme.html","title":"SvelteRender","type":"extras","doc":"SvelteRender WARNING: This is beta. Don&#39;t use in production unless you know what you&#39;re doing! Renders Svelte components as HTML"},{"ref":"readme.html#documentation","title":"SvelteRender - Documentation","type":"extras","doc":"The docs can be found at https://hexdocs.pm/svelte_render."},{"ref":"readme.html#installation","title":"SvelteRender - Installation","type":"extras","doc":"def deps do [ {:svelte_render, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"readme.html#getting-started-with-phoenix","title":"SvelteRender - Getting Started with Phoenix","type":"extras","doc":"Add svelte_render to your dependencies in package.json &quot;svelte_render&quot;: &quot;file:../deps/svelte_render&quot; Run npm install npm install Create a file named render_server.js in your assets folder and add the following module.exports = require(&#39;svelte_render/priv/server&#39;) Add SvelteRender to your Supervisor as a child. We&#39;re using the absolute path to ensure we are specifying the correct working directory that contains the render_server.js file we created earlier. children = [ %{ id: SvelteRender, start: {SvelteRender, :start_link, [[render_service_path: render_service_path, pool_size: 4]]}, type: :supervisor } ] Create a svelte component like: &lt;script&gt; export let params; &lt;/script&gt; &lt;p&gt;Hello from {name}&lt;/p&gt; &lt;style&gt; p { font-weight: normal; } &lt;/style&gt; Call SvelteRender.render/2 inside the action of your controller def index(conn, _params) do component_path = &quot;\#{File.cwd!()}/assets/src/components/HelloWorld.svelte&quot; props = %{params: %{name: &quot;Phoenix&quot;}} {:safe, helloWorld} = SvelteRender.render(component_path, props) render(conn, &quot;index.html&quot;, helloWorldComponent: helloWorld) end component_path can either be an absolute path or one relative to the render service. The stipulation is that components must be in the same path or a sub directory of the render service. This is so that the babel compiler will be able to compile it. The service will make sure that any changes you make are picked up. It does this by removing the component_path from node&#39;s require cache. If do not want this to happen, make sure to add NODE_ENV to your environment variables with the value production. Render the component in the template &lt;%= raw @helloWorldComponent %&gt; To add routing for your components, create a base component, e.g. assets/src/App.svelte and use page.js Taken from: https://jackwhiting.co.uk/posts/setting-up-routing-in-svelte-with-pagejs/ &lt;script&gt; import router from &#39;page&#39;; import Home from &#39;./routes/Home.svelte&#39;; let page; let params = {name: &quot;svelte&quot;}; router(&#39;/&#39;, () =&gt; page = Home) router.start(); &lt;/script&gt; &lt;svelte:component this={page} params={params} /&gt; To hydrate server-created components in the client, add the following to your app.js import App from &#39;./components/App.svelte&#39;; window.app = new App({ target: document.querySelector(&#39;#svelte&#39;), hydrate: true }); Example rollup config: The postcss configs allow you to import a global.scss file into your App.svelte like so: &lt;style global type=&quot;scss&quot; &gt; @import &quot;../styles/global.scss&quot;; &lt;/style&gt; import svelte from &#39;rollup-plugin-svelte&#39;; import resolve from &#39;@rollup/plugin-node-resolve&#39;; import commonjs from &#39;@rollup/plugin-commonjs&#39;; import { terser } from &#39;rollup-plugin-terser&#39;; import sveltePreprocess from &#39;svelte-preprocess&#39;; const production = !process.env.ROLLUP_WATCH; const preprocess = sveltePreprocess({ scss: { includePaths: [&#39;src&#39;], }, postcss: { plugins: [require(&#39;postcss-import&#39;)({path: [&#39;src/styles&#39;]})], }, }); export default { input: &#39;src/app.js&#39;, output: { sourcemap: true, format: &#39;iife&#39;, name: &#39;app&#39;, file: &#39;../priv/static/js/app.js&#39; }, plugins: [ svelte({ hydratable: true, // enable run-time checks when not in production dev: !production, preprocess, css: css =&gt; { css.write(&#39;../priv/static/css/app.css&#39;); } }), resolve({ browser: true, // a dependency in node_modules may have svelte inside it&#39;s node_modules folder // dedupe option prevents bundling those duplicates dedupe: [&#39;svelte&#39;] }), commonjs(), // If we&#39;re building for production (npm run build // instead of npm run dev), minify production &amp;&amp; terser() ], watch: { clearScreen: false } }; Add rollup to your list of watchers in config/dev.exs config :your_app, YourApp.Endpoint, http: [port: 4000], debug_errors: true, code_reloader: true, check_origin: false, watchers: [ rollup: [ &quot;--config&quot;, &quot;--watch&quot;, cd: Path.expand(&quot;../assets&quot;, __DIR__) ] ] You should now be able to run mix phx.server and your Svelte components with update with live reloading"},{"ref":"readme.html#development","title":"SvelteRender - Development","type":"extras","doc":"For debugging you can use priv/cli.js: node priv/cli --component &quot;/Full/path/to/Component.svelte&quot; --props &quot;{name: &#39;Svelte&#39;}&quot; // output: // { error: null, // markup: &#39;&lt;p&gt;Hello from Svelte&lt;/p&gt;&#39;, // component: &#39;/Users/you/Dev/project_folder/assets/src/Component.svelte&#39; }"}]